<?php
//
// ip_addr_stuff.inc.php : geolocalisation of IP@
//
//VGR08022006 : Cration from unified logwarn.php and eee.org/GetCountryFromIp and extra/Get*
//VGR14022006 FIXed bug in tryNsLookup
//            FIXed problem with silly RIPE email addresses for PROXAD.FR
//VGR22022006 ADDed searching for 'abuse-mailbox' first !!
//VGR04092006 MOD (FIX timeouts TODO?) from !sock
//VGR20092006 FIXed timeouts sur fgets() - line 270
//VGR07102006 ADDed fourth parameter to globalWhois() for fast calls (EEE.org)
//VGR13012007 ADDed scurit contre accs LAN et local
//VGR23012007 MOD adresse (serveurdedie -> grolier)
//VGR30052007 ADDed direct whois for RIPE when answering "access denied"
//VGR04062007 MOD GlobalWhoIs()  cause de co.uk et com.br
//VGR19092007 FIXed abuse@co.uk problem
//VGR31102007 DEL .kr whois
//            FIXed abuse@net.tr problem
//
// TODO : one timeout to fix ; see comments
//

function Nettoie($par,$debug=FALSE) { // nettoie l'INTERIEUR d'une chane des 0A ou 0A0D et espaces...
  if ($debug) echo "par entre = '".htmlspecialchars($par)."'<BR>";
  $poubStr=strip_tags(nl2br($par));
  if ($debug) echo "par stripp = '".htmlspecialchars($poubStr)."'<BR>";
  $poubStr=trim($poubStr);
  if ($debug) echo "poub lu hex = ".bin2hex($poubStr)."<BR>";
  if (!(strpos($poubStr,"\r\n")===FALSE)) {
    for ($i=1;($i<strlen($poubStr))and(substr($poubStr,$i,2)<>chr(13).chr(10));$i++) ;
    $poub2=substr($poubStr,0,$i);
    if ($debug) echo "poub2(1) i=$i hex = ".bin2hex($poub2)."<BR>";
    $j=$i; while (substr($poubStr,$j,2)==chr(13).chr(10)) $j+=2;
    if ($debug) echo " j=$j<BR>";
    while (substr($poubStr,$j,1)==' ') $j++;
    if ($debug) echo "poub2(2) hex = ".bin2hex(substr($poubStr,$j))."<BR>";
    $poub2.=" ".substr($poubStr,$j); // le reste
    $poub2=str_replace(chr(10),'',$poub2);
  } // if travail  faire
  else $poub2=str_replace(chr(10),'',$poubStr);
  if ($debug) echo "poub lu = ".htmlspecialchars($poubStr)."<BR>";
  if ($debug) echo "poub2 calc = ".htmlspecialchars($poub2)."<BR>";
  if ($debug) echo "poub2 hex = ".bin2hex($poub2)."<BR>";
  return($poub2);
} // Nettoie String Function

//VGR26062003 MODified URI called, infobear.com disappeared
//VGR23042006 ADDed possibilit de chercher sur nom de domaine (letype=1)
function tryNsLookup($IP,$debug=FALSE,$letype=0) { 
  $filename = "http://name.space.xs2.net/cgi-bin/nslookup.pl?pageid=DNS411&nsinput=$IP&submit=search";
  $contents=array();
  $resultat="";
  if ($debug) echo "NsLookup : let's call $filename<BR>";
  $fd=@fopen($filename,'r');
  if ($fd) {
    while (!feof ($fd)) {
      $ligne=fgets($fd, 4096);
      $contents []= $ligne;
    } // while lecture bloquante
    //  $contents = fread ($fd, filesize ($filename)); non bloquant : merdique
    fclose ($fd);
    $i=count($contents);
    $valsearch=($letype>0)?'Address':'Name:'; //VGR23042006 ADDed
    while (($i>0)AND(($a=strpos(@$contents[$i],$valsearch))===FALSE)) $i--; //VGR08022006 FIXed large as on 23072004
    if ($debug) echo "finished getting NsLookup, i=$i<BR>";
    if ($i>0) $resultat=trim(substr($contents[$i],$a+strlen($valsearch)+(($letype>0)?4:0))); // le reste //VGR14022006 FIXed +10 into +$a+5
    // ici contents[i] pointe sur (zb) "swtc180-41.adsl.seed.net.tw"
  } // if pas trouv
  return($resultat);
} // tryNsLookup String Function

function tryTraceroute($IP,$debug=FALSE) { 
  $filename = "http://www.eu.org/cgi-bin/nph-traceroute?$IP";
  $contents=array();
  $resultat="";
  if ($debug) echo "traceroute : let's call $filename<BR>";
  $fd = fopen ($filename, "r");
  $continue=0;
  $i=0;
  if ($fd) {
    while ((!feof ($fd))and ($continue<2)) {
      $ligne=fgets($fd, 4096);
      $contents []= $ligne;
      $i++;
      if (strpos('* * *',$ligne)>0) $continue++; else $continue=0;
    } // while lecture bloquante
    //  $contents = fread ($fd, filesize ($filename)); non bloquant : merdique
    fclose ($fd);
    if ($debug) echo "finished getting traceroute<BR>";
    $i=count($contents)-1;
    while (($i>0)AND(strpos($contents[$i],' ms')==0)) if ($debug) { echo "1 ".$contents[$i]."<BR>"; $i--; } else $i--;
    if ($i>0) while ((strpos($contents[$i],'*')>0) and (strpos($contents[$i],'*')<5)) if ($debug) { echo "2 ".$contents[$i]."<BR>"; $i--; } else $i--;
    // ici contents[i] pointe sur (zb) "12  paris11-nas8-55-25.dial.proxad.net (212.27.55.25)  209 ms  202 ms  199 ms"
    if ($i>0) $resultat=$contents[$i]; else $resultat='';
  } // else NOP
  return $resultat;
} // tryTraceroute String Function

$emailsTo="";
$emailsCC="";
$nbEmailsto=0;
$nbEmailscc=0;

function tryWhois($IP,$debug=FALSE) { 
  GLOBAL $emailsTo, $emailsCC, $locDomaine, $locMachine;
if ((substr($IP,0,9)<>'192.168.0')AND($IP<>'127.0.0.1')) { //VGR13012007 ADDed scurit contre accs LAN ou local
  $filename = "http://www.ripe.net/perl/whois?form_type=simple&full_query_string=&searchtext=$IP";
  if ($debug) echo "whois : let's call $filename<BR>";
  $fd2 = fopen ($filename, "r");
  while (!feof ($fd2)) {
    $contents2[]= fgets($fd2, 4096);
  } // while lecture bloquante
  fclose ($fd2);
  $i=0;
  while ((strpos($contents2[$i],'netname:')===FALSE) and ($i<count($contents2)-1)) {
    echo "skipped '".htmlspecialchars($contents2[$i])."'<br>";
    $i++; //VGR23072004 FIXed large
  }
  if ($i==count($contents2)) $locRes="non trouv";
  else { // l'lment I nous intresse
    $locRes=trim(substr($contents2[$i],13)); $i++;
    if ($locRes=='IANA-BLK') { // on essaie avec NsLookup
      if ($debug) echo "IANA-BLK, let's call NsLookup<BR>";
      $essai1=tryNsLookup($IP,$debug); // swtc180-41.adsl.seed.net.tw 
      $locMachine=$essai1;
      $z=explode('.',$essai1);
      if (count($z)>0) { // cas normal
        if (count($z)>2) { // cas normal
          $locDomaine=$z[count($z)-2].'.'.$z[count($z)-1];
        } else { // 1
          $locDomaine=$locMachine;
        }
      } else { // 0
        $locDomaine=$locMachine;
      }
      if ($debug) echo "essai1='$essai1'<BR>";
      if ($debug) echo "locMachine='$locMachine'<BR>";
      if ($debug) echo "locDomaine='$locDomaine'<BR>";
      $locRes=$locDomaine;
    } else {
      while (strpos($contents2[$i],'country:')===false) { $locRes.=" : ".substr($contents2[$i],13); $i++; } // plusieurs descr: possibles
      $locRes.=" (".substr($contents2[$i],13).")";
      // now set up email addresses
      $emailsTo=array();
      $emailsCC=array();
      // dans l'ordre : To: via trouble ou remarks + mot-clef "abuse" + adresse email rencontre
      // ensuite (CC) ou To (1re rencontre) les "e-mail:", "notify:" et "changed:"
      $i=0; while ($i<count($contents2)) { // passe
        while (($a=strpos($contents2[$i],'trouble:'))===false) $i++;
      } // passe
      if ($a) { // try to get an address from those remarks
        while ((($a=strpos($contents2[$i],'@'))===false)and(!(strpos($contents2[$i],'trouble:')===false))) $i++;
        if ($a) { // une adresse ml trouve
          $j=$i-1; while ($contents[$i][$j]<>' ') $j--;
          $k=$i+1; while ($contents[$i][$j]<>' ') $k++;
          $adresse=substr($contents[$i],$j+1,$k-$j);
          if ($debug) echo "adresse trouve = '$adresse'<BR>";
          // affectation
//          if (count($emailsTo)<2}
        } // else RF, on passe  la passe suivante
      } // if trouble trouv
    } // if domaine trouv dans RIPE
  } // if pas trouv
} else {
  $locRes='localhost (FR)';
  $emailsTo='vgr@edainworks.com';
  $emailsCC='';
  $locDomaine='localdomain';
  $locMachine='localhost';
}
/* exemple de bloc trouv : 
netname:     INFONIE
descr:       INFONIE
country:     BE
admin-c:     FB324-RIPE
tech-c:      AA696-RIPE
status:      ASSIGNED PA
mnt-by:      INFONIE-MNT
changed:     aandre@infonie.be 20000929
source:      RIPE
*/
  return $locRes;
} // tryWhois String Function

//VGR18022006 ADDed
$globDomaineQualite=0; // init private variable
$badones=array('com','org','net'); // idem
//
function AddEmail($adresse,&$deja,$debug=FALSE) {
  GLOBAL $globDomaineQualite, $badones, $locDomaine, $nbEmailsto, $nbEmailscc, $emailsTo, $emailsCC;
  //VGR24072004 FIXed test incorrect
  if ((isset($deja[$adresse]))AND($deja[$adresse])) { // rien
    if ($debug) echo "adresse '$adresse' dj place<BR>";
  } else {
    // affectation
    if ($nbEmailsto<2) { if ($nbEmailsto==1) $emailsTo.=", $adresse"; else $emailsTo="$adresse"; $nbEmailsto++; }
     else { if ($nbEmailscc==1) $emailsCC.=", $adresse"; else $emailsCC="$adresse"; $nbEmailscc++; }
    $deja[$adresse]=TRUE;
    //VGR18022006 ADDed
    $z=explode('@',$adresse);
    $locCandidat=$z[1];
    $z=explode('.',$locCandidat);
    $q=$z[count($z)-1];
    $locQ=(in_array($q,$badones))?1:2; // 2 is better quality than 1 (com,net,org)
    if ($debug) echo "new domaine candidat = '$locCandidat' (q=$locQ)<br>";
    if ($locQ>$globDomaineQualite) {
      $locDomaine=$locCandidat;
      $globDomaineQualite=$locQ;
      if ($debug) echo "found new domaine = '$locDomaine' (q=$globDomaineQualite)<br>";
    } // else NOP
    //EoAdd
  } // si pas dj prise
} // AddEmail Procedure

//EoAdd

//VGR22042006 ADDed DirectWhoIs() because of RIPE limitations when scripting
//VGR30052007 ADDed debug param
//
function DirectWhoIs($server,$locIP,$debug=FALSE) {
  if ($debug) echo "<font color='red'>DirectWhoIs() : entering with server=$server,ip=$locIP,debug=$debug</font><br>\n";
  $answer=array();
  if (!defined('NL')) define('NL',"\r\n"); //VGR01052006 FIX already defined
  $host = $server;
  $port = 43;
  $timeout = 30;
  $sock = fsockopen( $host , $port , $errno , $errstr , $timeout );
  if ( $sock===FALSE ) { //VGR04092006 MOD (FIX?) from !sock
    if ($debug) echo "<font color='red'>DirectWhoIs() : $errstr ( $errno )</font><br>\n";
  } else {
    $query = "$locIP".NL;
    if ($debug) echo "TCP query on host/port $host/$port = '$query<BR>'";
    fputs( $sock , $query );
    while ( !feof( $sock ) ) {
      $ligne=fgets( $sock , 2048 );
      $answer[]=$ligne;
      if ($debug) echo "$ligne<br>";
    }
    fclose($sock);
  }
  if ($debug) echo "termin, returning<br>";
  return($answer);
} // DirectWhoIs Boolean Function
//EoAdd

//VGR31032003 MODification  cause d'ARIN (format whois spcifique...)
//VGR09042003 ADDed cas ERX-NETBLOCK (early registration addresses dues  InternIC)
//            MODified APNIC  cause de 'Not allocated by' au lieu de 'not allocated to'
//VGR08022006 ADDed $tryslow as a parameter
//            ADDed $nbservers, $s, AfriNIC and KR, JP, TW
//VGR18022006 MOD via AddEmail(), modify locDomaine - with a quality level -
//VGR07102006 ADDed fourth parameter
//VGR01062007 ADDed fifth parameter
//VGR04062007 MOD  cause de co.uk et com.br
//
function globalWhois($IP,$debug=FALSE,$tryslow=FALSE,$fastmode=FALSE,$countryonly=FALSE) {
  GLOBAL $emailsTo, $emailsCC, $locDomaine, $locMachine, $nbEmailsto, $nbEmailscc, $netname;
if ((substr($IP,0,9)<>'192.168.0')AND($IP<>'127.0.0.1')) { //VGR13012007 ADDed scurit contre accs LAN ou local
  $tryslow=FALSE; $fastmode=FALSE;
  $server[0] = "http://www.ripe.net/perl/whois?form_type=simple".(($countryonly)?'&object_type=inetnum&recursive=ON':'')."&full_query_string=&searchtext=$IP"; $refus[0]='IANA-BLK'; $chemail[0]='e-mail:'; $chdescr[0]='descr:'; $chcountry[0]='country:'; $chnetname[0]='netname:';
  $server[1] = "http://www.apnic.net/apnic-bin/whois.pl?searchtext=$IP"; $refus[1]='ot allocated'; $chemail[1]='e-mail:'; $chdescr[1]='descr:'; $chcountry[1]='country:'; $chnetname[1]='netname:';
  $server[2] = "http://ws.arin.net/cgi-bin/whois.pl?queryinput=$IP"; $refus[2]='not registered in'; $chemail[2]='TechEmail:'; $chdescr[2]='Org'; $chcountry[2]='Country:'; $chnetname[2]='NetName:';
  $server[3] = "http://lacnic.net/cgi-bin/lacnic/whois?lg=EN&query=$IP"; $refus[3]='Not assigned to'; $chemail[3]='e-mail:'; $chdescr[3]='descr:'; $chcountry[3]='phone:'; $chnetname[3]='netname:';
  //VGR REM AFRINIC=4
  $s=4; $server[$s] = "http://www.afrinic.net/cgi-bin/whois?searchtext=$IP"; $refus[$s]='ALLOCATED UNSPECIFIED'; $chemail[$s]='e-mail:'; $chdescr[$s]='descr:'; $chcountry[$s]='country:'; $chnetname[$s]='netname:';
  $s=5; 
  //VGR31102007 DEL, no more useable (silly flash version) $server[$s] = "http://whois.nida.or.kr/whois/webapisvc?VALUE=$IP"; $refus[$s]='is not managed by KRNIC'; $chemail[$s]='E-Mail'; $chdescr[$s]='Org Name'; $chcountry[$s]='KR'; $chnetname[$s]='Network Name';
  //VGR03042008 ADDed new KR server
  $server[$s] = "http://whois.nic.or.kr/english/result.php?isp=1&domain_name=$IP"; $refus[$s]='is not managed by KRNIC'; $chemail[$s]='E-Mail'; $chdescr[$s]='Org Name'; $chcountry[$s]='KR'; $chnetname[$s]='Network Name';
  $s=6; $server[$s] = "http://whois.twnic.net/whois.cgi?query=$IP&sld=ip&submit2=search"; $refus[$s]='does not exist in our database'; $chemail[$s]='e-mail:'; $chdescr[$s]='descr:'; $chcountry[$s]='country:'; $chnetname[$s]='netname:';
  $s=7; $server[$s] = "http://whois.nic.ad.jp/cgi-bin/whois_gw?type=NET&key=$IP&rule=&lang=/e&submit=query"; $refus[$s]='No match!'; $chemail[$s]='e-mail:'; $chdescr[$s]='descr:'; $chcountry[$s]='country:'; $chnetname[$s]='netname:';
  $s=8; $server[$s] = "http://www.ripn.net/nic/whois/en/whois.cgi?Whois=$IP&Host='whois.ripe.net'"; $refus[$s]='IANA-BLK'; $chemail[$s]='e-mail:'; $chdescr[$s]='descr:'; $chcountry[$s]='country:'; $chnetname[$s]='netname:';
  $nbservers=count($server);
  //VGR14022006 ADDed inits
  $emailsTo=""; $emailsCC=""; $nbEmailsto=0; $nbEmailscc=0; $locDomaine='';
  //EoAdd
  // NB : $chdescr[] non utilis sauf pour ARIN
  $index=0;
  $notfound=TRUE;
  while (($notfound)and($index<$nbservers)) {
    $filename=$server[$index];
    $contents2=array(); // vidage
    $notalloc=FALSE; // itou
    if ($debug) echo "whois : let's call $filename<BR>";
    //VGR19032005 FIXed NOTICEs & WARNINGs going to into error_log
    $fd2=@fopen($filename,'r');
    //VGR21042006 ADDed use of DirectWhoIs() for RIPE
    if ($fd2===FALSE) {
      if ($index==0) {
        if ($debug) echo "RIPE :: DIRECT WHOIS<br>";
        $contents2=DirectWhoIs('whois.ripe.net',$IP); //VGR REM ajouter ,$debug pour dboguer...
        if (($j=count($contents2))>0) {
          $i=0;
          $ligne=$contents2[$i];
          while ((! $notalloc) AND ($i<$j)) { if ((strpos($ligne,$refus[$index])!==FALSE)or(strpos($ligne,'ERX-NETBLOCK')!==FALSE)) $notalloc=TRUE; $i++; $ligne=@$contents2[$i]; }
          $fd3=TRUE;
          if ($debug) echo "DIRECT WHOIS PASSED OK $j lines (".(($notalloc)?'notalloc':'okRipe').")<br>";
        } else { echo "<font color='red'>RIPE direct WHOIS returned the void</font><br>"; $fd3=FALSE; }
      } else { $index++; echo "<font color='red'>COULD NOT OPEN '$filename'</font><br>"; $fd3=FALSE; }
    } else {
      //EoFix
      if ($debug) echo "file opened ok<br>";
      //VGR20092006 FIXed timeout at maximum execution time (480 seconds)
      if ($fastmode) stream_set_blocking($fd2,FALSE);
      if ($fastmode) stream_set_timeout($fd2,2); // 2 secondes
      $notdone=TRUE; //VGR01102006 FIXed BUG hnaurme !!!
      $refused=FALSE; //VGR30052007 ADDed
      $j=-1;
      while ($notdone) {
        $ligne=@fgets($fd2, 4096);
        $j++;
        if ($fastmode) $info = stream_get_meta_data($fd2);
        if ($fastmode) if ($info['timed_out']) $notdone=FALSE;
        if ($notdone) {
          $notdone=(!feof($fd2));
          $contents2[]= $ligne;
          if ((strpos($ligne,$refus[$index])!==FALSE)or(strpos($ligne,'ERX-NETBLOCK')!==FALSE)) $notalloc=TRUE;
          if (strpos($ligne,'ERROR:201: access denied')!==FALSE) $refused=TRUE;
          if ($fastmode) if ($debug) if (!$notdone) echo "eof at pos $j<br>";
        }
      } // while lecture bloquante
      @fclose($fd2);
      //EoFix
      //VGR30052007 ADDed direct whois for RIPE
      if ($refused) { //VGR REM pas de test pour index==0 (RIPE)
        if ($debug) echo "RIPE WWW-REFUSED :: DIRECT WHOIS<br>";
        $contents2=DirectWhoIs('whois.ripe.net',$IP,$debug);
        if (($j=count($contents2))>0) {
          $i=0;
          $ligne=$contents2[$i];
          while ((! $notalloc) AND ($i<$j)) { if ((strpos($ligne,$refus[$index])!==FALSE)or(strpos($ligne,'ERX-NETBLOCK')!==FALSE)) $notalloc=TRUE; $i++; $ligne=@$contents2[$i]; }
          $fd3=TRUE;
          if ($debug) echo "DIRECT WHOIS PASSED OK $j lines (".(($notalloc)?'notalloc':'okRipe').")<br>";
        } else $fd3=FALSE;
      } // else NOP
      //EoAdd
      $fd3=TRUE; // fall-through
    }
    //EoAdd
//VGR01102006 DEBUG    if ($debug) echo "found ".count($contents2)." lines<br>";
    if ($fd3) {
      $locRes="non trouv"; // dfaut
      if ($notalloc) $index++;
      else {
       $i=0;
       if ($debug) echo "recherche ".$chnetname[$index]." <BR>";
       //VGR28102004 ADDed scurit contre "missing index 0"
       if (count($contents2)>0)
        while ((($a=strpos($contents2[$i],$chnetname[$index]))===FALSE) and ($i<count($contents2)-1)) {
//VGR01102006 DEBUG          echo "skipped $i '".htmlspecialchars($contents2[$i])."'<br>";
          $i++; //VGR23072004 FIXed large
        }
       else $a=FALSE;
       $poursuite=FALSE;
       if ($a===FALSE) { // on passe
         if ($debug) echo "lment ".$chnetname[$index]." non trouv<BR>";
         //VGR16042003 ADDed seconde chance pour les reassigned du lacnic
         if ($index==3) { // seconde chance sur "owner" ;-)
           $i=0;
           $chnetname[$index]='owner:';
           if ($debug) echo "recherche ".$chnetname[$index]." <BR>";
           while ( ($i<count($contents2)-1) AND (($a=strpos($contents2[$i],$chnetname[$index]))===FALSE) ) $i++; //VGR23072004 FIXed large //VGR02092005 FIXed order to prevent NOTICE
           if ($a===FALSE) { // on passe
             if ($debug) echo "lment ".$chnetname[$index]." non trouv<BR>";
             $locRes="non trouv"; // inutile
             $index++;
           } else {
             if ($debug) echo "lment ".$chnetname[$index]." trouv en seconde chance<BR>";
             $poursuite=TRUE;
           } // RF, c'est bon
         } else {
           //VGR08022005 ADDed cas classique de plusieurs niveaux de rponse
           $i=count($contents2)-1;
           while (($i>0)AND(($rs=strpos($contents2[$i],'/cgi-bin/whois.pl?queryinput=!%20NET'))===FALSE)) $i--;
           if ($i<=0) { // on passe (pas de description...)
             $locRes="non trouv"; // inutile
             $index++;
           } else { // yabon
             $rs2=$rs+10; while ($contents2[$i][$rs2]<>'"') $rs2++;
             $filename='http://ws.arin.net'.substr($contents2[$i],$rs,$rs2-$rs);
             if ($debug) echo "whois ARIN : let's call $filename<BR>";
             $fd2=@fopen($filename,'r');
             if ($fd2!==FALSE) {
               $contents2=array();
               while (!feof ($fd2)) {
                 $ligne=fgets($fd2, 4096);
                 $contents2[]= $ligne;
                 if ((strpos($ligne,$refus[$index])!==FALSE)or(strpos($ligne,'ERX-NETBLOCK')!==FALSE)) $notalloc=TRUE;
               } // while lecture bloquante
               fclose ($fd2);
               $i=0;
               if ($debug) echo "recherche ".$chnetname[$index]." <BR>";
//echo '<pre>'; print_r($contents2); echo '</pre>';
//exit;
               if (count($contents2)>0)
                while ((($a=strpos($contents2[$i],$chnetname[$index]))===FALSE) and ($i<count($contents2)-1)) $i++; //VGR23072004 FIXed large
               else $a=FALSE;
               if ($a===FALSE) { // on passe
                 $locRes="non trouv"; // inutile
                 $index++;
               } else {
                 $locRes=trim(substr($contents2[$i],12));
//if ($debug) echo "lment brut ".$chnetname[$index]." lu en $i = '".htmlspecialchars($locRes)."'<BR>";
                 $locRes=Nettoie($locRes,FALSE);
                 if ($debug) echo "poursuite1 lment ".$chnetname[$index]." lu en $i = $locRes<BR>";
                 $notfound=FALSE;
                 $netname=$locRes;
                 $i=0;
                 $limitici=count($contents2);
                 while ( ( (($a=strpos($contents2[$i],'CustName:'))===FALSE) AND (($a=strpos($contents2[$i],'OrgName:'))===FALSE) ) and ($i<$limitici-1)) {
                   if ($debug) echo "poursuite1 skipped ".htmlspecialchars($contents2[$i])." <br>";
                   $i++; //VGR23072004 FIXed large
                 }
if ($debug) echo "poursuite1 i=$i, limit=$limitici<br>";
                 while (($i<$limitici)AND(trim(Nettoie($contents2[$i]))<>'')AND(strpos($contents2[$i],$chcountry[$index])===false)) { $locRes.=" : ".Nettoie(substr($contents2[$i],12),FALSE); $i++; } // plusieurs descr: possibles
                 if ($i<$limitici) $locRes.=" (".Nettoie(substr($contents2[$i],12),FALSE).")";
                  else $locRes.=' [STOP]';
                 $poursuite=TRUE;
               } // if passe
             } else { $index++; echo "<font color='red'>COULD NOT OPEN '$filename'</font><br>"; }
           } // if yabon 2nd passe ARIN
           //EoAdd
         } // if index=3
       } else { // l'lment I nous intresse
if ($debug) echo "lment brutal lu en $i = '".htmlspecialchars($contents2[$i])."'<BR>";
         $locRes=trim(substr($contents2[$i],12));
if ($debug) echo "lment brut ".$chnetname[$index]." lu en $i = '".htmlspecialchars($locRes)."'<BR>";
         $locRes=Nettoie($locRes,FALSE);
         if ($debug) echo "lment ".$chnetname[$index]." lu en $i = $locRes<BR>";
         $i++;
         if ($locRes=='IANA-BLK') { // on passe
           $index++;
         } else if (strpos($locRes,'EU-ZZ')!==FALSE) { // on passe
           $index++;
         } else if ((substr($locRes,0,6)=='LACNIC')and ($index==2)) { // on passe (ARIN rfrence LACNIC)
           $index++;
         } else if ((substr($locRes,0,6)=='KRNIC')and ($index==2)) { // on passe (APNIC rfrence KRNIC)
//xxx
           $index++;
         } else if (strpos($locRes,'-TRANSFERRED')!==FALSE) { // AFRINIC
           $index=4; // AFRINIC
         } else {
           $notfound=FALSE;
           $netname=$locRes;
           if ($index<>2) { // cas normal
if ($debug) echo "poursuite2 lment ".$chnetname[$index]." lu en $i = $locRes<BR>";
             //VGR28092005 FIX
             $limitici=count($contents2);
             while (($i<$limitici)AND(strpos($contents2[$i],$chcountry[$index])===false)) { $locRes.=" : ".Nettoie(substr($contents2[$i],12),FALSE); $i++; } // plusieurs descr: possibles
             if ($i<$limitici) if ($index<>3) $locRes.=" (".Nettoie(substr($contents2[$i],12),FALSE).")"; //VGR14022006 ADDed <>3=lacnic=stopword
              else ; // stopword encountered
              else $locRes.=' [STOP]';
             //EoFix
             $poursuite=TRUE;
           } else { // cas ARIN
             $i=0;
             if ($debug) echo "recherche ".$chdescr[$index]." <BR>";
             while ((strpos($contents2[$i],$chdescr[$index])===FALSE) and ($i<count($contents2))) $i++;
             if ($i==count($contents2)) { // on passe (pas de description...)
             } else { // c'est bon
               $poursuite=TRUE;
//if ($debug) echo "lment brutal lu en $i = '".htmlspecialchars($contents2[$i])."'<BR>";
               $poubStr=trim(substr($contents2[$i],12));
//if ($debug) echo "lment brut ".$chdescr[$index]." lu en $i = '".htmlspecialchars($poubStr)."'<BR>";
               $locRes.=' : '.Nettoie($poubStr,FALSE);
               if ($debug) echo "lment ".$chdescr[$index]." lu en $i = '$poubStr'<BR>";
               $i++;
//if ($debug) echo "poursuite lment ".$chdescr[$index]." lu en $i = $locRes<BR>";
               while (strpos($contents2[$i],$chcountry[$index])===false) { $locRes.=" : ".Nettoie(substr($contents2[$i],12),FALSE); $i++; } // plusieurs descr: possibles
               $locRes.=" (".Nettoie(substr($contents2[$i],12),FALSE).")";
             } // found
           } // ARIN (2 passes) ou non
         } // if not cas particulier
       } // if pas trouv 'netname'
       
       if ($poursuite) {
         if ($debug) echo "poursuite<br>";
         // now set up email addresses
         $emailsTo="";
         $emailsCC="";
         $deja=array();
         $nbEmailsto=0;
         $nbEmailscc=0;
         // dans l'ordre : To: via trouble ou remarks + mot-clef "abuse" + adresse email rencontre
         // ensuite (CC) ou To (1re rencontre) les "e-mail:", "notify:" et "changed:"
         //VGR22022006 ADDed 'abuse' first !!
         $theval='abuse-mailbox';
         if ($debug) echo "recherche '$theval'<br>";
         $j=count($contents2);
         $i=0; while (($i<$j) and (($a=strpos($contents2[$i],$theval))===FALSE)) { $i++; }
//if ($debug) echo "reached i=$i (max=$j)<BR>";
         if ($i<$j) { // try to get an address from those remarks
//if ($debug) echo "found '$theval' in i=$i '".htmlspecialchars($contents2[$i])."'<BR>";
           //VGR22022006 ADDed cleaning HTML tags to get the link's text only (RIPE)
           $thestring=strip_tags($contents2[$i]);
//if ($debug) echo "built stripped string '$thestring'<BR>";
           while ((($a=strpos($thestring,'@'))===false)and(strpos($thestring,$theval)!==false)and($i<$j)) $i++;
//if ($debug) echo "inside search for @ reached i=$i '".htmlspecialchars($contents2[$i])."'<BR>";
           if (($i<$j)and($a)) { // une adresse ml trouve
//if ($debug) echo "mel@ found in i=$i<BR>";
             $j=$a-1; while (($j>-1)AND($thestring[$j]<>' ')) $j--;
             $k=$a+1; while (($k<strlen($thestring))and($thestring[$k]<>' ')) $k++;
             $adresse=trim(substr($thestring,$j+1,$k-$j));
             if (substr($adresse,0,7)=='mailto:') $adresse=substr($adresse,7); //VGR14022006 FIXed problem with silly RIPE for PROXAD.FR
             if ($debug) echo "adresse $theval trouve = '$adresse'<BR>";
             AddEmail($adresse,$deja,$debug);
           } // else RF, on passe  la passe suivante
         } // if trouble trouv
         $theval='abuse';
         if ($debug) echo "recherche '$theval'<br>";
         $i=0; while (($i<count($contents2)) and (($a=strpos($contents2[$i],$theval))===FALSE)) { $i++; }
         if ($i<count($contents2)) { // try to get an address from those remarks
           while ((($a=strpos($contents2[$i],'@'))===false)and(!(strpos($contents2[$i],$theval)===false))and($i<count($contents2))) $i++;
           if (($i<count($contents2))and($a)) { // une adresse ml trouve
             $j=$a-1; while (($j>-1)AND($contents2[$i][$j]<>' ')) $j--;
             $k=$a+1; while (($k<strlen($contents2[$i]))and($contents2[$i][$k]<>' ')) $k++;
             $adresse=trim(substr($contents2[$i],$j+1,$k-$j));
             if (substr($adresse,0,7)=='mailto:') $adresse=substr($adresse,7); //VGR14022006 FIXed problem with silly RIPE for PROXAD.FR
             AddEmail($adresse,$deja,$debug);
           } // else RF, on passe  la passe suivante
         } // if trouv 'changed'
         $theval='trouble:';
         if ($debug) echo "recherche '$theval'<br>";
         $i=0; while (($i<count($contents2)) and (($a=strpos($contents2[$i],$theval))===FALSE)) { $i++; }
         if ($i<count($contents2)) { // try to get an address from those remarks
           while ((($a=strpos($contents2[$i],'@'))===false)and(!(strpos($contents2[$i],$theval)===false))and($i<count($contents2))) $i++;
           if (($i<count($contents2))and($a)) { // une adresse ml trouve
             $j=$a-1; while (($j>-1)AND($contents2[$i][$j]<>' ')) $j--;
             $k=$a+1; while (($k<strlen($contents2[$i]))and($contents2[$i][$k]<>' ')) $k++;
             $adresse=trim(substr($contents2[$i],$j+1,$k-$j));
             if (substr($adresse,0,7)=='mailto:') $adresse=substr($adresse,7); //VGR14022006 FIXed problem with silly RIPE for PROXAD.FR
             if ($debug) echo "adresse $theval trouve = '$adresse'<BR>";
             AddEmail($adresse,$deja,$debug);
           } // else RF, on passe  la passe suivante
         } // if trouble trouv
         $theval='remarks:';
         if ($debug) echo "recherche '$theval'<br>";
         $i=0; while (($i<count($contents2)) and (($a=strpos($contents2[$i],$theval))===FALSE)) { $i++; }
         if ($i<count($contents2)) { // try to get an address from those remarks
           while ((($a=strpos($contents2[$i],'@'))===false)and(!(strpos($contents2[$i],$theval)===false))and($i<count($contents2))) $i++;
           //VGR07042003 ADDed scurit sur ($a)
           if (($i<count($contents2))and($a)) { // une adresse ml trouve
             //EoAdd
             $j=$a-1; while (($j>-1)AND($contents2[$i][$j]<>' ')) $j--;
             $k=$a+1; while (($k<strlen($contents2[$i]))and($contents2[$i][$k]<>' ')) $k++;
             $adresse=trim(substr($contents2[$i],$j+1,$k-$j));
             if (substr($adresse,0,7)=='mailto:') $adresse=substr($adresse,7); //VGR14022006 FIXed problem with silly RIPE for PROXAD.FR
             AddEmail($adresse,$deja,$debug);
           } // else RF, on passe  la passe suivante
         } // if trouv
         $theval=$chemail[$index];
         if ($debug) echo "recherche '$theval'<br>";
         $i=0; while (($i<count($contents2)) and (($a=strpos($contents2[$i],$theval))===FALSE)) { $i++; }
         if ($i<count($contents2)) { // try to get an address from those remarks
           while ((($a=strpos($contents2[$i],'@'))===false)and(!(strpos($contents2[$i],$theval)===false))and($i<count($contents2))) $i++;
           if (($i<count($contents2))and($a)) { // une adresse ml trouve
             $j=$a-1; while (($j>-1)AND($contents2[$i][$j]<>' ')) $j--;
             $k=$a+1; while (($k<strlen($contents2[$i]))and($contents2[$i][$k]<>' ')) $k++;
             $adresse=trim(substr($contents2[$i],$j+1,$k-$j));
             if (substr($adresse,0,7)=='mailto:') $adresse=substr($adresse,7); //VGR14022006 FIXed problem with silly RIPE for PROXAD.FR
             AddEmail($adresse,$deja,$debug);
           } // else RF, on passe  la passe suivante
         } // if trouv
         $theval='OrgAbuseEmail:';
         if ($debug) echo "recherche '$theval'<br>";
         $i=0; while (($i<count($contents2)) and (($a=strpos($contents2[$i],$theval))===FALSE)) { $i++; }
         if ($i<count($contents2)) { // try to get an address from those remarks
           while ((($a=strpos($contents2[$i],'@'))===false)and(!(strpos($contents2[$i],$theval)===false))and($i<count($contents2))) $i++;
           if (($i<count($contents2))and($a)) { // une adresse ml trouve
             $j=$a-1; while (($j>-1)AND($contents2[$i][$j]<>' ')) $j--;
             $k=$a+1; while (($k<strlen($contents2[$i]))and($contents2[$i][$k]<>' ')) $k++;
             $adresse=trim(substr($contents2[$i],$j+1,$k-$j));
             if (substr($adresse,0,7)=='mailto:') $adresse=substr($adresse,7); //VGR14022006 FIXed problem with silly RIPE for PROXAD.FR
             AddEmail($adresse,$deja,$debug);
           } // else RF, on passe  la passe suivante
         } // if trouv
       } // if poursuite
       else if ($debug) echo "PAS DE poursuite<br>";
     } // if notallocated
    } // if could open HTTP connection
  } // while not found
  if ($notfound AND $tryslow) { // on essaie avec NsLookup
      if ($debug) echo "IANA-BLK, let's call NsLookup<BR>";
      $essai1=tryNsLookup($IP,$debug); // swtc180-41.adsl.seed.net.tw  //VGR TODO timeouts on this line
      $locMachine=$essai1;
      $z=explode('.',$essai1);
      if (count($z)>0) { // cas normal //VGR19092007 FIXed abuse@co.uk problem : tt.co.uk
        if (count($z)>2) { // cas normal //VGR19092007 FIXed abuse@co.uk problem : tt.co.uk
          $locDomaine=$z[count($z)-2].'.'.$z[count($z)-1]; //VGR19092007 FIXed abuse@co.uk problem : co.uk
          //VGR04062007 MOD  cause de co.uk et com.br
          //VGR19092007 FIXed abuse@co.uk problem : tt.co.uk ; VGR31102007 idem net.tr
          if (($z[count($z)-2]=='co')OR($z[count($z)-2]=='com')OR($z[count($z)-2]=='net')) $locDomaine=$z[count($z)-3].'.'.$locDomaine;
          //EoFix
          //EoMod
        } else { // 1
          $locDomaine=$locMachine;
        }
      } else { // 0
        $locDomaine=$locMachine;
      }
      if ($debug) echo "essai1='$essai1'<BR>";
      if ($debug) echo "locMachine='$locMachine'<BR>";
      if ($debug) echo "locDomaine='$locDomaine'<BR>";
      $locRes=$locDomaine;
  }  // pas encore trouv
  //VGR21042006 ADDed protection
  if ((strpos($locRes,'RIPE')!==FALSE) and ($index<>0)) $locRes="non trouv";

} else { //VGR03052008 REM those are the (unused) settings for localdomain
  $locRes='localhost (FR)';
  $emailsTo='vgr@edainworks.com';
  $emailsCC='';
  $locDomaine='localdomain';
  $locMachine='localhost';
}
  //EoAdd
  return $locRes;
} // globalWhois String Function

?>